#include  "banner.h"
#include <QMessageBox>

#define BORDE 5
#define INC  2


CBanner::CBanner(QWidget *parent):QWidget(parent,Qt::Window){
    mover=false;
    redimensionar=NONE;
    marquesina=false;
    im=false;
    reloj=NULL;
    perm=NULL;
    velocity=0;
    setMouseTracking(true);
    updateMarco();
}
void CBanner::mouseMoveEvent(QMouseEvent *event){
    int x,y,dx,dy;
    x=event->x();
    y=event->y();
    dx=event->globalX()-lastmouseglobal.x();
    dy=event->globalY()-lastmouseglobal.y();

    updateCursor(x,y);
    if(mover)
        move(event->globalX()-lastposmouse.x(),event->globalY()-lastposmouse.y());
    if(redimensionar != NONE){
        if(redimensionar==BSI)
            setGeometry(event->globalX()-lastposmouse.x(),event->globalY()-lastposmouse.y(),
                        lastsize.width()-dx,lastsize.height()-dy);
        else if(redimensionar == BS)
            setGeometry(geometry().x(),event->globalY()-lastposmouse.y(),
                        lastsize.width(),lastsize.height()-dy);
        else if(redimensionar == BSD)
            setGeometry(geometry().x(),event->globalY()-lastposmouse.y(),
                        lastsize.width()+dx,lastsize.height()-dy);
        else if(redimensionar == BII)
            setGeometry(event->globalX()-lastposmouse.x(),geometry().y(),
                        lastsize.width()-dx,lastsize.height()+dy);
        else if(redimensionar == BI)
            setGeometry(geometry().x(),geometry().y(),
                        lastsize.width(),lastsize.height()+dy);
        else if(redimensionar == BID)
            setGeometry(geometry().x(),geometry().y(),
                        lastsize.width()+dx,lastsize.height()+dy);
        else if(redimensionar==BLI)
            setGeometry(event->globalX()-lastposmouse.x(),geometry().y(),
                        lastsize.width()-dx,lastsize.height());
        else if(redimensionar==BLD)
            setGeometry(geometry().x(),geometry().y(),
                        lastsize.width()+dx,lastsize.height());
    }
}
void CBanner::mousePressEvent(QMouseEvent *event){
    if(event->button()== Qt::LeftButton){
        if(marco.contains(event->pos()))
        {
            mover=true;
            setCursor(QCursor(Qt::ClosedHandCursor));
        }
        else{
            int x=event->x();
            int y=event->y();
            lastsize.setHeight(height());
            lastsize.setWidth(width());
            lastmouseglobal.setX(event->globalX());
            lastmouseglobal.setY(event->globalY());
            if(x < BORDE){
                if(y < BORDE)//A
                    redimensionar=BSI;
                else if(y > (BORDE+marco.height()) )//D
                    redimensionar=BII;
                else//H
                    redimensionar=BLI;
            }
            else if(x > (BORDE + marco.width() ) ){
                if(y < BORDE)//B
                    redimensionar=BSD;
                else if (y > (BORDE + marco.height() ))//C
                    redimensionar=BID;
                else//F
                    redimensionar=BLD;
            }
            else if(y < BORDE)//E
                redimensionar=BS;
            else if(y > (BORDE + marco.height() ) )//G
                redimensionar=BI;
            else
                redimensionar=NONE;
        }
        lastposmouse.setX(event->x());
        lastposmouse.setY(event->y());

    }
}
void CBanner::mouseReleaseEvent(QMouseEvent *event){
    if(event->button()== Qt::LeftButton){
        mover=false;
        redimensionar=NONE;
        setCursor(QCursor(Qt::OpenHandCursor));
    }
}
void CBanner::paintEvent(QPaintEvent *event){
    static int x=width();
    QPainter painter(this);
    painter.setPen(color_texto);
    if(im){
        painter.drawImage(marco,*Imagen,QRectF(0.0,0.0,Imagen->size().width(),Imagen->size().height()));
    }
    if(marquesina){
        QRect rtext = painter.boundingRect(rect(),Qt::AlignCenter,texto);
        x=x-INC;
        painter.drawText(x,size().height()/2-rtext.height()/2,
                         rtext.width(),rtext.height(),Qt::AlignVCenter|Qt::AlignCenter,texto);
        if (-x > rtext.width())
            x= width();
    }
    else{
        painter.drawText(rect(),Qt::AlignCenter,texto);
    }
}
void CBanner::resizeEvent(QResizeEvent *event){
    updateMarco();
}
void CBanner::setBackgroundColor(const QColor &color){
    QPalette palette;
    palette.setColor(backgroundRole(), color);
    setPalette(palette);
}
void CBanner::setBackgroundImage(const QString &file){
   Imagen = new QImage(file);
   if(Imagen->isNull())
       im = false;
   else
       im=true;
}
void CBanner::setText(const QString &ntexto){
    texto=ntexto;
}
void CBanner::setColorText(const QColor &ncolor){
    color_texto=ncolor;
}


void CBanner::setMarquee(bool active){
    if(marquesina==active)
        return;
    if(active){
        if(!reloj)
            reloj=new QTimer;
        marquesina=active;
        reloj->start(velocity);
        QObject::connect(reloj,SIGNAL(timeout()),this,SLOT(repaint()));
    }
    else{
        marquesina=active;
        QObject::disconnect(reloj,SIGNAL(timeout()),this,SLOT(repaint()));
    }
}
void CBanner::setAnimation(const QString &file){
}
void CBanner::setPermanencia(int min){
    tiempo_perm=min;
    if(tiempo_perm == 0){
        if(perm)//detenemos y ocultamos el banner
            QObject::disconnect(perm,SIGNAL(timeout()),this,SLOT(hide()));
    }
    if(!perm){
        perm=new QTimer;
        QObject::connect(perm,SIGNAL(timeout()),perm,SLOT(stop()));
    }//mostramos el banner con una permanencia de min minutos
    perm->start(tiempo_perm*1000*60);
    QObject::connect(perm,SIGNAL(timeout()),this,SLOT(hide()));
    show();
}
void CBanner::setVelocityMarquee(int value){
    velocity=(int)(50-0.47*value);
    if(reloj)
        reloj->start(velocity);
}

void CBanner::updateCursor(int x,int y){
    if(x < BORDE){
        if(y < BORDE)//A
            setCursor(QCursor(Qt::SizeFDiagCursor));
        else if(y > (BORDE+marco.height()) )//D
            setCursor(QCursor(Qt::SizeBDiagCursor));
        else//H
            setCursor(QCursor(Qt::SizeHorCursor));
    }
    else if(x > (BORDE + marco.width() ) ){
        if(y < BORDE)//B
            setCursor(QCursor(Qt::SizeBDiagCursor));
        else if (y > (BORDE + marco.height() ))//C
            setCursor(QCursor(Qt::SizeFDiagCursor));
        else//F
            setCursor(QCursor(Qt::SizeHorCursor));
    }
    else if(y < BORDE)//E
        setCursor(QCursor(Qt::SizeVerCursor));
    else if(y > (BORDE + marco.height() ) )//G
        setCursor(QCursor(Qt::SizeVerCursor));
    else{//Dentro del marco
        if (mover){
        }
        else
            setCursor(QCursor(Qt::OpenHandCursor));
    }
}
void CBanner::updateMarco(){
    marco.setRect(rect().x()+BORDE,rect().y()+BORDE,rect().width()-2*BORDE,rect().height()-2*BORDE);
}

