#ifndef _BANNER_H_
#define _BANNER_H_

#include <QtGui>
#include <QWidget>
#include <QString>
#include <QMouseEvent>
#include <QTimer>

enum TypeBorde{NONE,BSI,BSD,BID,BII,BLI,BS,BLD,BI};

class CBanner:public QWidget{
    Q_OBJECT
public:
    CBanner(QWidget *parent=0);
    virtual void mouseMoveEvent(QMouseEvent *event);
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent *event);
    virtual void paintEvent(QPaintEvent *event);
    virtual void resizeEvent(QResizeEvent *event);
    void setBackgroundColor(const QColor &color);
    void setBackgroundImage(const QString &file);
    void setText(const QString &ntexto);
    void setColorText(const QColor &ncolor);
    QString getText(){return texto;}
    QColor getColorText(){return color_texto;}
    void setMarquee(bool active);
    void setAnimation(const QString &file);
    void setPermanencia(int min);
public slots:
    void setVelocityMarquee(int value);
private:
    QColor color_texto;
    QString texto;
    QImage* Imagen;
    bool im;
    bool marquesina;
    QTimer *reloj;
    QTimer *perm;
    int velocity;
    int tiempo_perm;

private:
    void updateCursor(int x,int y);
    void updateMarco();
    bool mover;
    TypeBorde redimensionar;
    QRect marco;
    QPoint lastposmouse,lastmouseglobal;
    QSize lastsize;
};
#endif
